/*******************************
* ZK-80 web written by Katsumi *
*   This script is released    *
*     under the LGPL v2.1.     *
*******************************/

function clickStep(){
	if (cpu.step) {
		doStep();
	} else {
		cpu.step=1;
	}
}
function clickCont(){
	if (cpu.step) {
		cpu.step=0;
		start();
	}
}
function clickStopAt(val){
	if (val) {
		cpu.breakPoint=parseInt(val,16);
		if (cpu.step) {
			cpu.step=0;
			start();
		}
	}
}
function clickLogTo(val){
	if (val) {
		logto=parseInt(val,16);
		clickStep();
	} else {
		logto=0;
	}
}
function clickDump(val){
	if (val) {
		dump(parseInt(val,16));
	}
}

var log="";
var logto=0;
//cpu.breakPoint=0x09db;
function debug(str){
	dom.debug(str);
	log+=str+"\r\n";
	log=log.substr(-1000,1000);
}
function debugDisplay(addr,data){
	var str="";
	str+=(addr.toString(16)+" "+("0"+data.toString(16)).substr(-2,2)).toUpperCase()+" ";
	str+="("+("000"+cpu.regPC.toString(16)).substr(-4,4).toUpperCase()+") ";
	str+=new Date().getMilliseconds();
	str+="\r\n";
	str=str.substr(-200,200);
	if (200==str.length) {
		str=str.substr(str.indexOf("\n")+1);
	}
	dom.displaylog(str);
}
function showRegisters(){
	var str="";
	str+="PC:"+("000"+cpu.regPC.toString(16)).substr(-4,4).toUpperCase()+" ";
	str+="SP:"+("000"+(0xfc0|cpu.regSP).toString(16)).substr(-4,4).toUpperCase()+" ";
	str+="A:"+cpu.regA.toString(16).toUpperCase()+" ";
	str+="B:"+cpu.regB.toString(16).toUpperCase()+" ";
	str+="C:"+cpu.regC.toString(16).toUpperCase()+" ";
	str+="H:"+cpu.regH.toString(16).toUpperCase()+" ";
	str+="L:"+cpu.regL.toString(16).toUpperCase()+" ";
	str+="S:"+("0"+cpu.regS.toString(16)).substr(-2,2).toUpperCase()+"<br />\r\n";
	str+="--ZC:00"+((cpu.regF>>1)&1)+(cpu.regF&1)+"<br />\r\n";
	if (this.prevstr) {
		var str2="";
		for (i=str.length-1;0<=i;i--) {
			if (this.prevstr.charAt(i)==str.charAt(i)) {
				str2=str.charAt(i)+str2;
			} else {
				str2="<b>"+str.charAt(i)+"</b>"+str2;
			}
		}
		this.prevstr=str;
		str=str2;
	} else {
		this.prevstr=str;
	}
	if (this.prevcode) str+="(done:"+this.prevcode+") ";
	str+=this.prevcode=disasm1(cpu.regPC,cpu.regS);
	debug(str);
}
function dump(from){
	var str="";
	var addr,data;
	for (addr=from;addr<from+64;addr+=2) {
		if ((addr&0xf)==0 || str=="") str+=("000"+addr.toString(16).toUpperCase()).substr(-4,4);
		data=(memory.read(addr)<<4)|memory.read(addr+1);
		str+=" "+("0"+data.toString(16)).substr(-2,2).toUpperCase();
		if ((addr&0xe)==0xe) str+="\r\n";
	}
	dom.dump(str);
}
function doStep(){
	if (logto) {
		var log="";
		do {
			cpu.exec(1);
			log+=cpu.regPC.toString(16)+" "+disasm1(cpu.regPC)+"\r\n";
		} while (cpu.regPC!=logto);
		dom.displaylog(log);
		logto=0;
	} else {
		cpu.exec(1);
	}
	showRegisters();
	dump(cpu.regPC);
}
function disasm1(addr,regS){
	var code=(memory.read(addr)<<4)|memory.read(addr+1);
	var scode=("0"+code.toString(16)).substr(-2).toUpperCase();
	switch(code){
		case 0x00: return scode+' NOP';
		case 0x01: return scode+' LD A,B';
		case 0x02: return scode+' LD A,C';
		case 0x03: return scode+' LD A,(HL)';
		case 0x04: return scode+' LD A,H';
		case 0x05: return scode+' LD A,L';
		case 0x06: return scode+' LD A,Sh';
		case 0x07: return scode+' LD A,Sl';
		case 0x08: return scode+' LD B,A';
		case 0x09: return scode+' RET';
		case 0x0A: return scode+' LD B,C';
		case 0x0B: return scode+' LD B,(HL)';
		case 0x0C: return scode+' LD B,H';
		case 0x0D: return scode+' LD B,L';
		case 0x0E: return scode+' LD B,Sh';
		case 0x0F: return scode+' LD B,Sl';
		case 0x10: return scode+' LD C,A';
		case 0x11: return scode+' LD C,B';
		case 0x12: return scode+' IN A,(C)';
		case 0x13: return scode+' LD C,(HL)';
		case 0x14: return scode+' LD C,H';
		case 0x15: return scode+' LD C,L';
		case 0x16: return scode+' LD C,Sh';
		case 0x17: return scode+' LD C,Sl';
		case 0x18: return scode+' LD (HL),A';
		case 0x19: return scode+' LD (HL),B';
		case 0x1A: return scode+' LD (HL),C';
		case 0x1B: return scode+' OUT (C),A';
		case 0x1C: return scode+' LD (HL),H';
		case 0x1D: return scode+' LD (HL),L';
		case 0x1E: return scode+' LD (HL),Sh';
		case 0x1F: return scode+' LD (HL),Sl';
		case 0x20: return scode+' LD H,A';
		case 0x21: return scode+' LD H,B';
		case 0x22: return scode+' LD H,C';
		case 0x23: return scode+' LD H,(HL)';
		case 0x24: return scode+' IF C';
		case 0x25: return scode+' LD H,L';
		case 0x26: return scode+' LD H,Sh';
		case 0x27: return scode+' LD H,Sl';
		case 0x28: return scode+' LD L,A';
		case 0x29: return scode+' LD L,B';
		case 0x2A: return scode+' LD L,C';
		case 0x2B: return scode+' LD L,(HL)';
		case 0x2C: return scode+' LD L,H';
		case 0x2D: return scode+' IF NC';
		case 0x2E: return scode+' LD L,Sh';
		case 0x2F: return scode+' LD L,Sl';
		case 0x30: return scode+' LD Sh,A';
		case 0x31: return scode+' LD Sh,B';
		case 0x32: return scode+' LD Sh,C';
		case 0x33: return scode+' LD Sh,(HL)';
		case 0x34: return scode+' LD Sh,H';
		case 0x35: return scode+' LD Sh,L';
		case 0x36: return scode+' IF Z';
		case 0x37: return scode+' LD Sh,Sl';
		case 0x38: return scode+' LD Sl,A';
		case 0x39: return scode+' LD Sl,B';
		case 0x3A: return scode+' LD Sl,C';
		case 0x3B: return scode+' LD Sl,(HL)';
		case 0x3C: return scode+' LD Sl,H';
		case 0x3D: return scode+' LD Sl,L';
		case 0x3E: return scode+' LD Sl,Sh';
		case 0x3F: return scode+' IF NZ';
		case 0x40: return scode+' INC A';
		case 0x41: return scode+' INC B';
		case 0x42: return scode+' INC C';
		case 0x43: return scode+' INC (HL)';
		case 0x44: return scode+' INC H';
		case 0x45: return scode+' INC L';
		case 0x46: return scode+' INC Sh';
		case 0x47: return scode+' INC Sl';
		case 0x48: return scode+' DEC A';
		case 0x49: return scode+' DEC B';
		case 0x4A: return scode+' DEC C';
		case 0x4B: return scode+' DEC (HL)';
		case 0x4C: return scode+' DEC H';
		case 0x4D: return scode+' DEC L';
		case 0x4E: return scode+' DEC Sh';
		case 0x4F: return scode+' DEC Sl';
		case 0x50: return scode+' PUSH A';
		case 0x51: return scode+' PUSH B';
		case 0x52: return scode+' PUSH C';
		case 0x53: return scode+' PUSH F';
		case 0x54: return scode+' PUSH H';
		case 0x55: return scode+' PUSH L';
		case 0x56: return scode+' PUSH Sh';
		case 0x57: return scode+' PUSH Sl';
		case 0x58: return scode+' POP A';
		case 0x59: return scode+' POP B';
		case 0x5A: return scode+' POP C';
		case 0x5B: return scode+' POP F';
		case 0x5C: return scode+' POP H';
		case 0x5D: return scode+' POP L';
		case 0x5E: return scode+' POP Sh';
		case 0x5F: return scode+' POP Sl';
		case 0x60: return scode+' ADD A';
		case 0x61: return scode+' ADD B';
		case 0x62: return scode+' ADD C';
		case 0x63: return scode+' ADD (HL)';
		case 0x64: return scode+' ADC A';
		case 0x65: return scode+' ADC B';
		case 0x66: return scode+' ADC C';
		case 0x67: return scode+' ADC (HL)';
		case 0x68: return scode+' SUB A';
		case 0x69: return scode+' SUB B';
		case 0x6a: return scode+' SUB C';
		case 0x6b: return scode+' SUB (HL)';
		case 0x6c: return scode+' SBC A';
		case 0x6d: return scode+' SBC B';
		case 0x6e: return scode+' SBC C';
		case 0x6f: return scode+' SBC (HL)';
		case 0x70: return scode+' AND A';
		case 0x71: return scode+' AND B';
		case 0x72: return scode+' AND C';
		case 0x73: return scode+' AND (HL)';
		case 0x74: return scode+' OR A';
		case 0x75: return scode+' OR B';
		case 0x76: return scode+' OR C';
		case 0x77: return scode+' OR (HL)';
		case 0x78: return scode+' CP A';
		case 0x79: return scode+' CP B';
		case 0x7a: return scode+' CP C';
		case 0x7b: return scode+' CP (HL)';
		case 0x7c: return scode+' XOR A';
		case 0x7d: return scode+' XOR B';
		case 0x7e: return scode+' XOR C';
		case 0x7f: return scode+' XOR (HL)';
		default:
			break;
	}
	if (code<0xc0) return scode+' LD S,'+("0"+(code-0x80).toString(16)).substr(-2).toUpperCase();
	if (typeof regS!="undefined") {
		code+=regS<<6;
		if (code&0x01) return scode+' CALL '+("000"+(code-0xC1).toString(16)).substr(-4).toUpperCase();
		return scode+' JP '+("000"+(code-0xC0).toString(16)).substr(-4).toUpperCase();
	}
	if (code&0x01) return scode+' CALL '+("0"+(code-0xC1).toString(16)).substr(-2).toUpperCase();
	return scode+' JP '+("0"+(code-0xC0).toString(16)).substr(-2).toUpperCase();
}
