/*******************************
* ZK-40 web written by Katsumi *
*   This script is released    *
*     under the LGPL v2.1.     *
*******************************/

// Choose CPU
cpu=zk40cpu;
// Initialize CPU
var speed=10000; // 10 khz
dom.showSpeed(speed);
var maxspeed=speed;
cpu.setSpeed(speed);
cpu.reset();
cpu.events=function(){
	io.events();
};
// Initialize Memory
memory.program=[// Tiny test program
0x80,0x0f,0x89,0x27,0x84,0x2f,0xa0,0xfd,0x49,0x49,0x51,0x89,0x17,0x52,0x80,0xd1,
0x5a,0x4a,0x3f,0xa0,0xda,0x59,0x80,0x27,0x80,0x2f,0xa0,0xfd,0xa0,0xc4,0x80,0x17,
0x01,0x41,0x1b,0x04,0x42,0x1b,0x4a,0x01,0x41,0x1b,0x05,0x42,0x1b,0x09
];
memory.init();
// The other initializations
if (get.debug  && typeof debugDisplay !="undefined") {
	// Show the debug buttons
	dom.showDebug();
}
if (get.clock) {
	// Over or under clock setting.
	switch (get.clock.substr(-1)) {
		case "k": case "K":
			maxspeed=speed=parseFloat(get.clock.substr(0,get.clock.length-1))*1000;
			break;
		case "m": case "M":
			maxspeed=speed=parseFloat(get.clock.substr(0,get.clock.length-1))*1000000;
			break;
		case "g": case "G":
			maxspeed=speed=parseFloat(get.clock.substr(0,get.clock.length-1))*1000000000;
			break;
		default:
			maxspeed=speed=parseInt(get.clock,10);
			break;
	}
	cpu.setSpeed(speed);
	dom.showSpeed(speed);
}
/*if (get.start) {
	// Immediate start user program from specified address.
	cpu.loadPC(parseInt(get.start,16));
	memory.write(0x83c7,0x00);
	memory.write(0x83c8,0x00);
	cpu.loadSP(0x83c7);
}//*/
// Following function will be called after initializing display.
start=function(){
	var time;
	time=new Date().getTime();
	setTimeout(function(){
			var from=time;
			var to=time=new Date().getTime();
			var msec=to-from;
			if (msec<100 && speed<maxspeed) {
				speed<<=1;
				if (maxspeed<speed) speed=maxspeed;
				cpu.setSpeed(speed);
				dom.showSpeed(speed);
			} else if (250<msec) {
				speed>>=1;
				if (speed<1) speed=1;
				cpu.setSpeed(speed);
				dom.showSpeed(speed);
			}
			cpu.exec(msec);
			if (cpu.step) {
				showRegisters();
			} else {
				setTimeout(arguments.callee,10);
			}
		},10);
};
