/*******************************
* ZK-40 web written by Katsumi *
*   This script is released    *
*     under the LGPL v2.1.     *
*******************************/

/*
	Public methods:
	memory.read(addr);
	memory.write(addr,data);
	memory.init();
	
	This object requires memory.rom array containing 1024 bytes monitor program.
*/
memory=new Object();
memory.ram=Array(0x1000);
memory.init=function(){
	var i;
	for (i=0;i<this.ram.length;i++) {
		this.ram[i]=0;
	}
	if (this.rom) {
		for (i=0;i<this.rom.length;i++) {
			this.ram[(i<<1)+0]=this.rom[i]>>4;
			this.ram[(i<<1)+1]=this.rom[i]&0x0f;
		}
	}
	if (this.program) {
		for (i=0;i<this.program.length;i++) {
			this.ram[(i<<1)+0x0800]=this.program[i]>>4;
			this.ram[(i<<1)+0x0801]=this.program[i]&0x0f;
		}
	}
};
memory.read=function(addr){
	return this.ram[addr&0xfff];
};
memory.write=function(addr,data){
	addr&=0xfff;
	data&=0x0f;
	console.log('memory: '+addr.toString(16)+' => '+data.toString(16));
	if (addr<(this.rom.length<<1)) { // ROM
		return;
	} else { // RAM
		this.ram[addr]=data;
	}
};
